diff -ruNp linux-2.6.16.5/mm/mmap.c linux-2.6.16.5-cher1/mm/mmap.c
--- linux-2.6.16.5/mm/mmap.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/mm/mmap.c	2006-04-13 11:55:22.000000000 +0400
@@ -234,8 +234,13 @@ asmlinkage unsigned long sys_brk(unsigne
 
 	/* Check against rlimit.. */
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
-	if (rlim < RLIM_INFINITY && brk - mm->start_data > rlim)
+	if (rlim < RLIM_INFINITY && brk - mm->start_data > rlim) {
+                if ((current->flags & PF_MEMLIMITON)) {
+                        current->flags |= PF_MEMLIMITERR;
+                        send_sig(SIGKILL, current, 0);
+                }
 		goto out;
+        }
 
 	/* Check against existing mmap mappings. */
 	if (find_vma_intersection(mm, oldbrk, newbrk+PAGE_SIZE))
@@ -1458,8 +1463,13 @@ static int acct_stack_growth(struct vm_a
 		return -ENOMEM;
 
 	/* Stack limit test */
-	if (size > rlim[RLIMIT_STACK].rlim_cur)
+	if (size > rlim[RLIMIT_STACK].rlim_cur) {
+                if ((current->flags & PF_MEMLIMITON)) {
+                        current->flags |= PF_MEMLIMITERR;
+                        send_sig(SIGKILL, current, 0);
+                }
 		return -ENOMEM;
+        }
 
 	/* mlock limit tests */
 	if (vma->vm_flags & VM_LOCKED) {
@@ -2057,7 +2067,18 @@ int may_expand_vm(struct mm_struct *mm, 
 
 	lim = current->signal->rlim[RLIMIT_AS].rlim_cur >> PAGE_SHIFT;
 
-	if (cur + npages > lim)
+        if (cur + npages > lim) {
+                if ((current->flags & PF_MEMLIMITON)) {
+                        current->flags |= PF_MEMLIMITERR;
+                        send_sig(SIGKILL, current, 0);
+                }
 		return 0;
+        }
 	return 1;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/mm/mprotect.c linux-2.6.16.5-cher1/mm/mprotect.c
--- linux-2.6.16.5/mm/mprotect.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/mm/mprotect.c	2006-04-13 11:55:22.000000000 +0400
@@ -187,6 +187,9 @@ sys_mprotect(unsigned long start, size_t
 	if (grows == (PROT_GROWSDOWN|PROT_GROWSUP)) /* can't be both */
 		return -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (start & ~PAGE_MASK)
 		return -EINVAL;
 	if (!len)
@@ -280,3 +283,9 @@ out:
 	up_write(&current->mm->mmap_sem);
 	return error;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/mm/mremap.c linux-2.6.16.5-cher1/mm/mremap.c
--- linux-2.6.16.5/mm/mremap.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/mm/mremap.c	2006-04-13 11:55:22.000000000 +0400
@@ -408,8 +408,17 @@ asmlinkage unsigned long sys_mremap(unsi
 {
 	unsigned long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	down_write(&current->mm->mmap_sem);
 	ret = do_mremap(addr, old_len, new_len, flags, new_addr);
 	up_write(&current->mm->mmap_sem);
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/mm/swapfile.c linux-2.6.16.5-cher1/mm/swapfile.c
--- linux-2.6.16.5/mm/swapfile.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/mm/swapfile.c	2006-04-13 11:55:22.000000000 +0400
@@ -1099,7 +1099,9 @@ asmlinkage long sys_swapoff(const char _
 	char * pathname;
 	int i, type, prev;
 	int err;
-	
+
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -1338,6 +1340,8 @@ asmlinkage long sys_swapon(const char __
 	struct inode *inode = NULL;
 	int did_down = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	spin_lock(&swap_lock);
@@ -1714,3 +1718,9 @@ int valid_swaphandles(swp_entry_t entry,
 	spin_unlock(&swap_lock);
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/net/compat.c linux-2.6.16.5-cher1/net/compat.c
--- linux-2.6.16.5/net/compat.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/net/compat.c	2006-04-13 11:55:22.000000000 +0400
@@ -535,6 +535,9 @@ asmlinkage long compat_sys_socketcall(in
 	u32 a[6];
 	u32 a0, a1;
 				 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (call < SYS_SOCKET || call > SYS_RECVMSG)
 		return -EINVAL;
 	if (copy_from_user(a, args, nas[call]))
@@ -602,3 +605,9 @@ asmlinkage long compat_sys_socketcall(in
 	}
 	return ret;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/net/socket.c linux-2.6.16.5-cher1/net/socket.c
--- linux-2.6.16.5/net/socket.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/net/socket.c	2006-04-13 11:55:23.000000000 +0400
@@ -1194,6 +1194,9 @@ asmlinkage long sys_socket(int family, i
 	int retval;
 	struct socket *sock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = sock_create(family, type, protocol, &sock);
 	if (retval < 0)
 		goto out;
@@ -1220,6 +1223,9 @@ asmlinkage long sys_socketpair(int famil
 	struct socket *sock1, *sock2;
 	int fd1, fd2, err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/*
 	 * Obtain the first socket and check if the underlying protocol
 	 * supports the socketpair call.
@@ -1291,6 +1297,9 @@ asmlinkage long sys_bind(int fd, struct 
 	char address[MAX_SOCK_ADDR];
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if((sock = sockfd_lookup(fd,&err))!=NULL)
 	{
 		if((err=move_addr_to_kernel(umyaddr,addrlen,address))>=0) {
@@ -1320,6 +1329,9 @@ asmlinkage long sys_listen(int fd, int b
 	struct socket *sock;
 	int err;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((sock = sockfd_lookup(fd, &err)) != NULL) {
 		if ((unsigned) backlog > sysctl_somaxconn)
 			backlog = sysctl_somaxconn;
@@ -1355,6 +1367,9 @@ asmlinkage long sys_accept(int fd, struc
 	int err, len;
 	char address[MAX_SOCK_ADDR];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	sock = sockfd_lookup(fd, &err);
 	if (!sock)
 		goto out;
@@ -1425,6 +1440,9 @@ asmlinkage long sys_connect(int fd, stru
 	char address[MAX_SOCK_ADDR];
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	sock = sockfd_lookup(fd, &err);
 	if (!sock)
 		goto out;
@@ -1455,6 +1473,9 @@ asmlinkage long sys_getsockname(int fd, 
 	char address[MAX_SOCK_ADDR];
 	int len, err;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	sock = sockfd_lookup(fd, &err);
 	if (!sock)
 		goto out;
@@ -1485,6 +1506,9 @@ asmlinkage long sys_getpeername(int fd, 
 	char address[MAX_SOCK_ADDR];
 	int len, err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((sock = sockfd_lookup(fd, &err))!=NULL)
 	{
 		err = security_socket_getpeername(sock);
@@ -1516,6 +1540,9 @@ asmlinkage long sys_sendto(int fd, void 
 	struct msghdr msg;
 	struct iovec iov;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	sock = sockfd_lookup(fd, &err);
 	if (!sock)
 		goto out;
@@ -1570,6 +1597,9 @@ asmlinkage long sys_recvfrom(int fd, voi
 	char address[MAX_SOCK_ADDR];
 	int err,err2;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	sock = sockfd_lookup(fd, &err);
 	if (!sock)
 		goto out;
@@ -1616,6 +1646,9 @@ asmlinkage long sys_setsockopt(int fd, i
 	int err;
 	struct socket *sock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (optlen < 0)
 		return -EINVAL;
 			
@@ -1646,6 +1679,9 @@ asmlinkage long sys_getsockopt(int fd, i
 	int err;
 	struct socket *sock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((sock = sockfd_lookup(fd, &err))!=NULL)
 	{
 		err = security_socket_getsockopt(sock, level, 
@@ -1674,6 +1710,9 @@ asmlinkage long sys_shutdown(int fd, int
 	int err;
 	struct socket *sock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if ((sock = sockfd_lookup(fd, &err))!=NULL)
 	{
 		err = security_socket_shutdown(sock, how);
@@ -1713,6 +1752,9 @@ asmlinkage long sys_sendmsg(int fd, stru
 	struct msghdr msg_sys;
 	int err, ctl_len, iov_size, total_len;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	err = -EFAULT;
 	if (MSG_CMSG_COMPAT & flags) {
 		if (get_compat_msghdr(&msg_sys, msg_compat))
@@ -1814,6 +1856,9 @@ asmlinkage long sys_recvmsg(int fd, stru
 	struct sockaddr __user *uaddr;
 	int __user *uaddr_len;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (MSG_CMSG_COMPAT & flags) {
 		if (get_compat_msghdr(&msg_sys, msg_compat))
 			return -EFAULT;
@@ -1916,6 +1961,9 @@ asmlinkage long sys_socketcall(int call,
 	unsigned long a0,a1;
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if(call<1||call>SYS_RECVMSG)
 		return -EINVAL;
 
@@ -2105,3 +2153,9 @@ EXPORT_SYMBOL(sock_wake_async);
 EXPORT_SYMBOL(sockfd_lookup);
 EXPORT_SYMBOL(kernel_sendmsg);
 EXPORT_SYMBOL(kernel_recvmsg);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.16.5/security/keys/keyctl.c linux-2.6.16.5-cher1/security/keys/keyctl.c
--- linux-2.6.16.5/security/keys/keyctl.c	2006-04-13 00:27:57.000000000 +0400
+++ linux-2.6.16.5-cher1/security/keys/keyctl.c	2006-04-13 11:55:23.000000000 +0400
@@ -40,6 +40,9 @@ asmlinkage long sys_add_key(const char _
 	void *payload;
 	long dlen, ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	ret = -EINVAL;
 	if (plen > 32767)
 		goto error;
@@ -138,6 +141,9 @@ asmlinkage long sys_request_key(const ch
 	char type[32], *description, *callout_info;
 	long dlen, ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* pull the type into kernel space */
 	ret = strncpy_from_user(type, _type, sizeof(type) - 1);
 	if (ret < 0)
@@ -1076,6 +1082,9 @@ error:
 asmlinkage long sys_keyctl(int option, unsigned long arg2, unsigned long arg3,
 			   unsigned long arg4, unsigned long arg5)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (option) {
 	case KEYCTL_GET_KEYRING_ID:
 		return keyctl_get_keyring_ID((key_serial_t) arg2,
@@ -1154,3 +1163,9 @@ asmlinkage long sys_keyctl(int option, u
 	}
 
 } /* end sys_keyctl() */
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
